# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices/configuration.html#application-related-configuration
parameters:
    diplome_images: '%kernel.project_dir%/public/uploads/diplomes'
    avatar_directory: '%kernel.project_dir%/public/uploads/avatar'
    csv_directory: '%kernel.project_dir%/public/data'
    formation_directory: '%kernel.project_dir%/public/formation'
    document_directory: '%kernel.project_dir%/public/document'

services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.
        bind:
            string $uploadsDirectory: '%kernel.project_dir%/public/uploads/'
            $projectDir: '%kernel.project_dir%'

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/'
        exclude:
            - '../src/DependencyInjection/'
            - '../src/Entity/'
            - '../src/Kernel.php'
            - '../src/Tests/'

    # controllers are imported separately to make sure services can be injected
    # as action arguments even if you don't extend any base controller class
    App\Controller\:
        resource: '../src/Controller/'
        tags: ['controller.service_arguments']

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones
    App\Service\FileUploader:
        arguments:
            $targetDirectory: '%csv_directory%'

    App\EventListener\NotificationDiplomeController:
        tags:
            - { name: 'doctrine.orm.entity_listener', event: 'postRemove', entity: 'App\Entity\Diplome' }

    App\EventListener\EmailAfterAccountCreate:
        tags:
            - { name: 'doctrine.orm.entity_listener', event: 'postPersist', entity: 'App\Entity\User' }

    App\EventListener\DelegueCount:
        tags:
            - { name: 'doctrine.orm.entity_listener', event: 'prePersist', lazy: true }

    Lyra\PayzenBundle\Payzen\:
        resource: '../Lyra/payzen-bundle/Payzen'
        arguments: ['%site_id%', '%key_test%', '%key_prod%', '%ctx_mode%', '%sign_algo%', '%platform_url%']

    Lyra\PayzenBundle\Controller\:
        resource: '../Lyra/payzen-bundle/Controller'
        tags: ['controller.service_arguments']
